Ucourbe(L):={
local F,f,B;
local j,dx,nbp,P;
local xmin,xmax,ymin,ymax,ux,uy,cx,cy,gx,gy;
local textp,ip,etatc,val;
local T,N,V,textt;
local t,a,b,xtmin,xtmax,dt,tmin,tmax,df;
local li,g,sol,texts;
local texta,Q,texti,grillage;

F:=L[0];

xmin:=L[1];
xmax:=L[2];
ymin:=L[3];
ymax:=L[4];

ux:=L[5];
uy:=L[6];
cx:=L[7];
cy:=L[8];
gx:=L[9];
gy:=L[10];

T:=L[11];

grillage:="
draw grillehori(xmin,xmax,ymin,ymax,dx,dy,grady) dashed evenly withcolor gris;
draw grilleverti(xmin,xmax,ymin,ymax,dx,dy,gradx) dashed evenly withcolor gris;
";


f:=unapply(F[0],x);
df:=unapply(deriver(F[0]),x);

if (size(F)==3) then
{
  B:=F[2];
  xtmin:=max(xmin,B[0]);
  xtmax:=min(xmax,B[1]);
}
else
{
  xtmin:=xmin;
  xtmax:=xmax;
}

nbp:=200;
dx:=evalf((xtmax-xtmin)/nbp);
P:=makemat(0,1,nbp+1);


etatc:=0;
nbc:=0;
textp:=("");

for (j:=0;j<=nbp;j++)
{
  x:=evalf(xtmin+j*dx);
  if (abs(x)<0.0001) then
  {
    x:=0;
  }
  val:=f(x);
  if (abs(val)<0.0001) then
  {
    val:=0;
  }
  if ((val>ymin-5) and (val<ymax+5)and (val!=infinity) and (im(val)==0))
  {
    if (etatc==0) then
    {
      etatc:=1;
      nbc:=nbc+1;
      ip:=1;
      P[0]:=[x,val];
      textp:=concat(textp,"P[1]:=("+evalf(x)+","+evalf(val)+");
");
    }
    else
    {
      P[ip]:=[x,val];
      ip:=ip+1;
      textp:=concat(textp,"P["+(ip)+"]:=("+evalf(x)+","+evalf(val)+");
");
    }
   }
   else
   {
     if (etatc==1) then
     {
       etatc:=0;
       textp:=concat(textp,"

draw P[1] placer
for i:=2 upto ");
       textp:=concat(textp,""+ip+"");
       textp:=concat(textp,":
  ..P[i] placer
endfor
withcolor "+F[1]+" withpen pencircle scaled 1.bp;

");
     }
   }
}

if (etatc==1) then
{
  etatc:=0;
  textp:=concat(textp,"

draw P[1] placer
for i:=2 upto ");
textp:=concat(textp,""+ip+"");
textp:=concat(textp,":
  ..P[i] placer
endfor
withcolor "+F[1]+" withpen pencircle scaled 1.bp;

");
}

// dessin des extremites

if (size(F)==3) then
{
  B:=F[2];
  if (size(B)==3) then
  {
    if ((B[2]=="ff") or (B[2]=="fo")) then
    {
      tmin:=f(xtmin);
      if (abs(tmin)<0.0001) then
      {
        tmin:=0;
      }
      textp:=concat(textp,"dotlabel(TEX(\" \"),("+evalf(xtmin)+","+evalf(tmin)+")placer) withcolor  "+F[1]+";
");
    }
    if ((B[2]=="ff") or (B[2]=="of")) then
    {
      tmax:=f(xtmax);
      if (abs(tmax)<0.0001) then
      {
        tmax:=0;
      }
      textp:=concat(textp,"dotlabel(TEX(\" \"),("+evalf(xtmax)+","+evalf(tmax)+")placer) withcolor  "+F[1]+";
");
    }
  }
}


                        //  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                        //       % Traitement des options

N:=size(T);
textt:=("%%%%%%%%%%%%%%%% Complements %%%%%%%%%%%%%%%%%%%%%%%%

");

texti:=("%%%%%%%%%%%%%%%% titres %%%%%%%%%%%%%%%%%%%%%%%%

");

if (N!=0) then
{
  for(j:=0;j<=N-1;j++)
  {
    V:=T[j];

////////////////////////////////////////////////////////////////////////////////////////////////////





////////////////////    grille  ///////////////////////////////////////////////

    if (V[0]=="grille") then
    {
      if (V[1]=="millimetre") then
      {
        grillage:="
draw grillehori(xmin,xmax,ymin,ymax,dx,dy,0.1)  withcolor gris;
draw grilleverti(xmin,xmax,ymin,ymax,dx,dy,0.1)  withcolor gris;
draw grillehori(xmin,xmax,ymin,ymax,dx,dy,0.5) withcolor gris_V  ;
draw grilleverti(xmin,xmax,ymin,ymax,dx,dy,0.5)  withcolor gris_V  ;
draw grillehori(xmin,xmax,ymin,ymax,dx,dy,1) withcolor gris_III  ;
draw grilleverti(xmin,xmax,ymin,ymax,dx,dy,1)  withcolor gris_III  ;
";
      }
      else
      {
        colg:="gris";
        if (V[1]=="plein") then
        {
          typetrace:=" "
        };
        if (V[1]=="hachure") then
        {
          typetrace:=" dashed evenly"
        };
        if (V[1]=="pointille") then
        {
          typetrace:=" dashed withdots withpen pencircle scaled 1.2bp"
        };
        if (size(V)==3) then
        {
          colg:=V[2]
        };
        grillage:="
draw grillehori(xmin,xmax,ymin,ymax,dx,dy,grady) withcolor "+colg+typetrace+";
draw grilleverti(xmin,xmax,ymin,ymax,dx,dy,gradx) withcolor "+colg+typetrace+";";
     }
   };



/////////////////////////////////////////////////////////////////////////////////


    if (V[0]=="tangente") then
    {
      textt:=concat(textt,"%%%%%%%%%%%%%%%% Tangente %%%%%%%%%%%%%%%%%%%%%%%%

");
      t:=V[1];
      a:=df(t);
      dt:=V[5];
      xtmin:=evalf(t-dt);
      xtmax:=evalf(t+dt);
      tmin:=evalf(a*(xtmin-t)+f(t));
      if (abs(tmin)<0.0001) then
      {
        tmin:=0;
      }
      tmax:=evalf(a*(xtmax-t)+f(t));
      if (abs(tmax)<0.0001) then
      {
        tmax:=0;
      }
      val:=f(t);
      if (abs(val)<0.0001) then
      {
        val:=0;
      }
      textt:=concat(textt,"drawdblarrow ("+xtmin+","+tmin+") placer--("+xtmax+","+tmax+") placer withcolor "+V[4]+";
");
      textt:=concat(textt,"label."+V[3]+"(TEX(\" "+V[2]+" \"),("+t+","+evalf(val)+") placer) withcolor "+V[4]+";
");
      textt:=concat(textt,"draw("+t+","+evalf(f(t))+") placer shifted (-0.1cm,0)--("+t+","+evalf(val)+") placer shifted (0.1cm,0) withcolor "+V[4]+";
");
      textt:=concat(textt,"draw("+t+","+evalf(f(t))+") placer shifted (0,-0.1cm)--("+t+","+evalf(val)+") placer shifted (0,0.1cm) withcolor "+V[4]+";
");
      if (size(V)==7) then
      {
        if ((V[6,0]=="x") or (V[6,0]=="xy")) then
        {
          textt:=concat(textt,"draw("+t+",0) placer--("+t+","+evalf(val)+") placer dashed evenly withcolor  "+V[4]+";
");
          if (size(V[6])==1) then
          {
            if (f(t)>0) then
            {
              textt:=concat(textt,"label.bot(TEX(\" $"+latex(t)+"$ \"),("+t+",0) placer) withcolor  "+V[4]+";
");
            }
            else
            {
              textt:=concat(textt,"label.top(TEX(\" $"+latex(t)+"$ \"),("+t+",0) placer) withcolor  "+V[4]+";
");
            }
          }
          else
          {
            if (f(t)>0) then
            {
              textt:=concat(textt,"label.bot(TEX(\" "+V[6,1]+" \"),("+t+",0) placer) withcolor  "+V[4]+";
");
            }
            else
            {
              textt:=concat(textt,"label.top(TEX(\" "+V[6,1]+" \"),("+t+",0) placer) withcolor  "+V[4]+";
");
            }
          }
        }
        if ((V[6,0]=="y") or (V[6,0]=="xy")) then
        {
          textt:=concat(textt,"draw(0,"+evalf(val)+") placer--("+t+","+evalf(val)+") placer dashed evenly withcolor  "+V[4]+";
");
          if (size(V[6])==1) then
          {
            if (t>0) then
            {
              textt:=concat(textt,"label.lft(TEX(\" $"+latex(simplifier(f(t)))+"$ \"),(0,"+evalf(val)+") placer) withcolor  "+V[4]+";
");
            }
            else
            {
              textt:=concat(textt,"label.rt(TEX(\" $"+latex(simplifier(f(t)))+"$ \"),(0,"+evalf(val)+") placer) withcolor  "+V[4]+";
");
            }
          }
          else
          {
            if (t>0) then
            {
              textt:=concat(textt,"label.lft(TEX(\" "+V[6,2]+" \"),(0,"+evalf(val)+") placer) withcolor  "+V[4]+";
");
            }
            else
            {
              textt:=concat(textt,"label.rt(TEX(\" "+V[6,2]+" \"),(0,"+evalf(val)+") placer) withcolor  "+V[4]+";
");
            }

          }
        }
      }
    }




////////////////////////////////////////////////////////////////////////////////////////////////////

    if (V[0]=="point-courbe") then
    {
      textt:=concat(textt,"%%%%%%%%%%%%%%%% Point sur courbe %%%%%%%%%%%%%%%%%%%%%%%%

");
      t:=evalf(V[1]);
      val:=f(t);
      if (abs(val)<0.0001) then
      {
        val:=0;
      }
      textt:=concat(textt,"label."+V[3]+"(TEX(\" "+V[2]+" \"),("+t+","+evalf(val)+") placer) withcolor "+V[4]+";
");
      textt:=concat(textt,"draw("+t+","+evalf(val)+") placer shifted (-0.1cm,0)--("+t+","+evalf(val)+") placer shifted (0.1cm,0) withcolor "+V[4]+";
");
          textt:=concat(textt,"draw("+t+","+evalf(val)+") placer shifted (0,-0.1cm)--("+t+","+evalf(val)+") placer shifted (0,0.1cm) withcolor "+V[4]+";
");
      if (size(V)==6) then
      {
        if ((V[5,0]=="x") or (V[5,0]=="xy")) then
        {
          textt:=concat(textt,"draw("+t+",0) placer--("+t+","+evalf(val)+") placer dashed evenly withcolor  "+V[4]+";
");
          if (size(V[5])==1) then
          {
            if (val>0) then
            {
              textt:=concat(textt,"label.bot(TEX(\"$ "+latex(V[1])+" $\"),("+t+",0) placer) withcolor  "+V[4]+";
");
            }
            else
            {
              textt:=concat(textt,"label.top(TEX(\"$ "+latex(V[1])+" $\"),("+t+",0) placer) withcolor  "+V[4]+";
");
            }
          }
          else
          {
            if (val>0) then
            {
              textt:=concat(textt,"label.bot(TEX(\" "+V[5,1]+" \"),("+t+",0) placer) withcolor  "+V[4]+";
");
            }
            else
            {
              textt:=concat(textt,"label.top(TEX(\" "+V[5,1]+" \"),("+t+",0) placer) withcolor  "+V[4]+";
");
            }
          }
        }
        if ((V[5,0]=="y") or (V[5,0]=="xy")) then
        {
          textt:=concat(textt,"draw(0,"+evalf(val)+") placer--("+t+","+evalf(val)+") placer dashed evenly withcolor  "+V[4]+";
");
          if (size(V[5])==1) then
          {
            if (t>0) then
            {
              textt:=concat(textt,"label.lft(TEX(\"$ "+latex(evalf(val))+" $\"),(0,"+evalf(val)+") placer) withcolor  "+V[4]+";
");
            }
            else
            {
              textt:=concat(textt,"label.rt(TEX(\"$ "+latex(evalf(val))+" $\"),(0,"+evalf(val)+") placer) withcolor  "+V[4]+";
");
            }
          }
          else
          {
            if (t>0) then
            {
              textt:=concat(textt,"label.lft(TEX(\" "+V[5,2]+" \"),(0,"+evalf(val)+") placer) withcolor  "+V[4]+";
");
            }
            else
            {
              textt:=concat(textt,"label.rt(TEX(\" "+V[5,2]+" \"),(0,"+evalf(val)+") placer) withcolor  "+V[4]+";
");
            }

          }
        }
      }
    }





////////////////////////////////////////////////////////////////////////////////////////////////////

    if (V[0]=="point-libre") then
    {
      textt:=concat(textt,"%%%%%%%%%%%%%%%% Point libre %%%%%%%%%%%%%%%%%%%%%%%%

");
      xtmin:=evalf(V[1,0]);
      tmin:=evalf(V[1,1]);
      textt:=concat(textt,"label."+V[3]+"(TEX(\" "+V[2]+" \"),("+xtmin+","+tmin+") placer) withcolor "+V[4]+";
");
      textt:=concat(textt,"draw("+xtmin+","+tmin+") placer shifted (-0.1cm,0)--("+xtmin+","+tmin+") placer shifted (0.1cm,0) withcolor "+V[4]+";
");
      textt:=concat(textt,"draw("+xtmin+","+tmin+") placer shifted (0,-0.1cm)--("+xtmin+","+evalf(tmin)+") placer shifted (0,0.1cm) withcolor "+V[4]+";
");

      if (size(V)==6) then
      {
        if ((V[5,0]=="x") or (V[5,0]=="xy")) then
        {
          textt:=concat(textt,"draw("+xtmin+",0) placer--("+xtmin+","+tmin+") placer dashed evenly withcolor  "+V[4]+";
");

          if (size(V[5])==1) then
          {
            if (tmin>0) then
            {
              textt:=concat(textt,"label.bot(TEX(\"$ "+latex(V[1,0])+" $\"),("+xtmin+",0) placer) withcolor  "+V[4]+";
");
            }
            else
            {
              textt:=concat(textt,"label.top(TEX(\"$ "+latex(V[1,0])+" $\"),("+xtmin+",0) placer) withcolor  "+V[4]+";
");
            }
          }
          else
          {
            if (tmin>0) then
            {
              textt:=concat(textt,"label.bot(TEX(\" "+V[5,1]+" \"),("+xtmin+",0) placer) withcolor  "+V[4]+";
");
            }
            else
            {
              textt:=concat(textt,"label.top(TEX(\" "+V[5,1]+" \"),("+xtmin+",0) placer) withcolor  "+V[4]+";
");
            }
          }
        }
        if ((V[5,0]=="y") or (V[5,0]=="xy")) then
        {
          textt:=concat(textt,"draw(0,"+tmin+") placer--("+xtmin+","+tmin+") placer dashed evenly withcolor  "+V[4]+";
");
          if (size(V[5])==1) then
          {
            if (xtmin>0) then
            {
              textt:=concat(textt,"label.lft(TEX(\"$ "+latex(V[1,1])+" $\"),(0,"+tmin+") placer) withcolor  "+V[4]+";
");
            }
            else
            {
              textt:=concat(textt,"label.rt(TEX(\"$ "+latex(V[1,1])+" $\"),(0,"+tmin+") placer) withcolor  "+V[4]+";
");
            }
          }
          else
          {
            if (xtmin>0) then
            {
              textt:=concat(textt,"label.lft(TEX(\" "+V[5,2]+" \"),(0,"+tmin+") placer) withcolor  "+V[4]+";
");
            }
            else
            {
              textt:=concat(textt,"label.rt(TEX(\" "+V[5,2]+" \"),(0,"+tmin+") placer) withcolor  "+V[4]+";
");
            }

          }
        }
      }
    }


//////////////////////////////////////////////////////////////////////////////////////////////////////////////

    if (V[0]=="droite-verti") then
    {
      textt:=concat(textt,"%%%%%%%%%%%%%%%% Droite verticale %%%%%%%%%%%%%%%%%%%%%%%%

");
      t:=evalf(V[1]);
      textt:=concat(textt,"draw ("+t+","+ymin+") placer--("+t+","+ymax+") placer withcolor "+V[2]+";
");

    }



//////////////////////////////////////////////////////////////////////////////////////////////////////////////

    if (V[0]=="asymp-verti") then
    {
      textt:=concat(textt,"%%%%%%%%%%%%%%%% Asymptote verticale %%%%%%%%%%%%%%%%%%%%%%%%

");
      t:=evalf(V[1]);
      li:=V[2];
      if (size(li)==2) then
      {
        textt:=concat(textt,"drawdblarrow ("+t+","+ymin+") placer--("+t+","+ymax+") placer withcolor "+V[3]+";
");
        textt:=concat(textt,"drawdblarrow ("+t+","+ymin+")placer shifted(0,1.1*ahlength)--("+t+","+ymax+") placer shifted(0,-1.1*ahlength) withcolor "+V[3]+";
");
      }
      else
      {
        if (li[0]==+infinity) then
        {
          textt:=concat(textt,"drawarrow ("+t+","+ymin+") placer--("+t+","+ymax+") placer withcolor "+V[3]+";
");
          textt:=concat(textt,"drawarrow ("+t+","+ymin+")placer--("+t+","+ymax+") placer shifted(0,-1.1*ahlength) withcolor "+V[3]+";
");
        }
        else
        {
          textt:=concat(textt,"drawarrow ("+t+","+ymax+") placer--("+t+","+ymin+") placer withcolor "+V[3]+";
");
          textt:=concat(textt,"drawarrow ("+t+","+ymax+")placer--("+t+","+ymin+") placer shifted(0,1.1*ahlength) withcolor "+V[3]+";
");
        }
      }
    }

//////////////////////////////////////////////////////////////////////////////////////////////////////////////

    if (V[0]=="asymp-hori") then
    {
      textt:=concat(textt,"%%%%%%%%%%%%%%%% Asymptote horizontale %%%%%%%%%%%%%%%%%%%%%%%%

");
      t:=evalf(V[1]);
      li:=V[2];
      if (size(li)==2) then
      {
        textt:=concat(textt,"drawdblarrow ("+xmin+","+t+") placer--("+xmax+","+t+") placer withcolor "+V[3]+";
");
        textt:=concat(textt,"drawdblarrow ("+xmin+","+t+")placer shifted(1.1*ahlength,0)--("+xmax+","+t+") placer shifted(-1.1*ahlength,0) withcolor "+V[3]+";
");
      }
      else
      {
        if (li[0]==+infinity) then
        {
          textt:=concat(textt,"drawarrow ("+xmin+","+t+") placer--("+xmax+","+t+") placer withcolor "+V[3]+";
");
          textt:=concat(textt,"drawarrow ("+xmin+","+t+")placer--("+xmax+","+t+") placer shifted(-1.1*ahlength,0) withcolor "+V[3]+";
");
        }
        else
        {
          textt:=concat(textt,"drawarrow ("+xmax+","+t+") placer--("+xmin+","+t+") placer withcolor "+V[3]+";
");
          textt:=concat(textt,"drawarrow ("+xmax+","+t+")placer--("+xmin+","+t+") placer shifted(1.1*ahlength,0) withcolor "+V[3]+";
");
        }
      }
    }

//////////////////////////////////////////////////////////////////////////////////////////////////////////////

    if (V[0]=="asymp-obli") then
    {
      textt:=concat(textt,"%%%%%%%%%%%%%%%% Asymptote oblique %%%%%%%%%%%%%%%%%%%%%%%%

");
      g:=unapply(V[1],x);
      tmin:=evalf(g(xmin));

      // test de la borne gauche
      if (tmin<ymin) then
      {
        sol:=solve(g(x)=ymin,x);
        xtmin:=sol[0];
      }
      if ((tmin>=ymin)and(tmin<=ymax)) then
      {
        xtmin:=xmin;
      }
      if (tmin>ymax) then
      {
        sol:=solve(g(x)=ymax,x);
        xtmin:=sol[0];
      }
      tmax:=evalf(g(xmax));
      // test de la borne droite
      if (tmax<ymin) then
      {
        sol:=solve(g(x)=ymin,x);
        xtmax:=sol[0];
      }
      if ((tmax>=ymin)and(tmax<=ymax)) then
      {
        xtmax:=xmax;
      }
      if (tmax>ymax) then
      {
        sol:=solve(g(x)=ymax,x);
        xtmax:=sol[0];
      }
      xtmin:=evalf(xtmin);
      xtmax:=evalf(xtmax);
      tmin:=evalf(g(xtmin));
      if (abs(tmin)<0.0001) then
      {
        tmin:=0;
      }
      tmax:=evalf(g(xtmax));
      if (abs(tmax)<0.0001) then
      {
        tmax:=0;
      }
      li:=V[2];
      if (size(li)==2) then
      {
        textt:=concat(textt,"
a:=("+xtmin+","+tmin+") placer;
b:=("+xtmax+","+tmax+") placer;
c:=b-(b-a)/abs(b-a)*1.1*ahlength;
d:=a-(a-b)/abs(a-b)*1.1*ahlength;
drawdblarrow a--b withcolor "+V[3]+";
drawdblarrow d--c withcolor "+V[3]+";
");
      }
      else
      {
        if (li[0]==+infinity) then
        {
          textt:=concat(textt,"
a:=("+xtmin+","+tmin+") placer;
b:=("+xtmax+","+tmax+") placer;
c:=b-(b-a)/abs(b-a)*1.1*ahlength;
drawarrow a--b withcolor "+V[3]+";
drawarrow a--c withcolor "+V[3]+";
");
        }
        else
        {
          textt:=concat(textt,"
a:=("+xtmax+","+tmax+") placer;
b:=("+xtmin+","+tmin+") placer;
c:=b-(b-a)/abs(b-a)*1.1*ahlength;
drawarrow a--b withcolor "+V[3]+";
drawarrow a--c withcolor "+V[3]+";
");
        }
      }
    }

////////////////////////////////////////////////////////////////////////////////////////////////////

    if (V[0]=="texte-courbe") then
    {
      textt:=concat(textt,"%%%%%%%%%%%%%%%% Texte lie a la courbe %%%%%%%%%%%%%%%%%%%%%%%%

");
      t:=V[1];
      val:=f(t);
      if (abs(val)<0.0001) then
      {
        val:=0;
      }
      texts:=V[2];
      textt:=concat(textt,"label."+V[3]+"(TEX(\" \\colorbox\{white\}\{\\textcolor\{"+V[4]+"\}\{");
      textt:=concat(textt,texts);
      textt:=concat(textt,"\}\} \"),("+evalf(t)+","+evalf(val)+") placer);
");
    }



////////////////////////////////////////////////////////////////////////////////////////////////////

    if (V[0]=="texte-libre") then
    {
      textt:=concat(textt,"%%%%%%%%%%%%%%%% Texte libre %%%%%%%%%%%%%%%%%%%%%%%%

");
      xtmin:=evalf(V[1,0]);
      tmin:=evalf(V[1,1]);
      texts:=V[2];
      textt:=concat(textt,"label."+V[3]+"(TEX(\" \\colorbox\{white\}\{\\textcolor\{"+V[4]+"\}\{");
      textt:=concat(textt,texts);
      textt:=concat(textt,"\}\} \"),("+xtmin+","+tmin+") placer);
");
    }


////////////////////////////////////////////////////////////////////////////////////////////////////

    if (V[0]=="titre-gauche") then
    {
      texti:=concat(texti,"%%%%%%%%%%%%%%%% Titre a gauche %%%%%%%%%%%%%%%%%%%%%%%%

");
      texti:=concat(texti,"titre:=1;
");
      texti:=concat(texti,"label.rt(TEX(\" "+V[1]+" \"),(xmin,ymax) placer shifted (0,0.7cm));
");
    }


////////////////////////////////////////////////////////////////////////////////////////////////////

    if (V[0]=="titre-droite") then
    {
      texti:=concat(texti,"%%%%%%%%%%%%%%%% Titre a droite %%%%%%%%%%%%%%%%%%%%%%%%

");
      texti:=concat(texti,"titre:=1;
");
      texti:=concat(texti,"label.lft(TEX(\" "+V[1]+" \"),(xmax,ymax) placer shifted (0,0.7cm));
");
    }



////////////////////////////////////////////////////////////////////////////////////////////////////

    if (V[0]=="titre-centre") then
    {
      texti:=concat(texti,"%%%%%%%%%%%%%%%% Titre centre %%%%%%%%%%%%%%%%%%%%%%%%

");
      texti:=concat(texti,"titre:=1;
");
      texti:=concat(texti,"label(TEX(\" "+V[1]+" \"),((xmin+xmax)/2,ymax) placer shifted (0,0.7cm));
");
    }



////////////////////////////////////////////////////////////////////////////////////////////////////

    if (V[0]=="aire-sous-courbe") then
    {
      textt:=concat(textt,"%%%%%%%%%%%%%%%% Aire sous la courbe %%%%%%%%%%%%%%%%%%%%%%%%

");
      xtmin:=evalf(V[1]);
      xtmax:=evalf(V[2]);
      texta:=("");
      nbp:=50;
      dx:=evalf((xtmax-xtmin)/nbp);
      for (k:=0;k<=nbp;k++)
      {
        x:=evalf(xtmin+k*dx);
        if (abs(x)<0.0001) then
        {
          x:=0;
        }
        val:=f(x);
        if (abs(val)<0.0001) then
        {
          val:=0;
        }
        texta:=concat(texta,"P["+(k+1)+"]:=("+evalf(x)+","+evalf(val)+");
");
      }

      textt:=concat(textt,texta);
      if (size(V)==4) then
      {
         textt:=concat(textt,"aire:=
("+xtmin+",0) placer--P[1] placer
for i:=2 upto 51:
  ..P[i] placer
endfor
--("+xtmax+",0) placer --cycle;
fillcolor:=1.3"+V[3]+";
transparence aire;
draw aire;
");
     }
     else
     {
        textt:=concat(textt,"aire:=
("+xtmin+",0) placer--P[1] placer
for i:=2 upto 51:
  ..P[i] placer
endfor
--("+xtmax+",0) placer --cycle;
draw hachurage(aire,30,4mm,0)"+V[3]+";
draw aire;
");
     }




    }


///////////////////////////////////////////////////////////////////////////////////////////////////

    if (V[0]=="base") then
    {
       textt:=concat(textt,"
label.bot(TEX(\"$\\vec{i}$\"),(0.5,0)placer);
drawarrow (0,0)placer--(1,0)placer;
label.lft(TEX(\"$\\vec{j}$\"),(0,0.5)placer);
drawarrow (0,0)placer--(0,1)placer;
label.llft(TEX(\"$O$\"),(0,0)placer);
")
    };



////////////////////////////////////////////////////////////////////////////////////////////////////

    if (V[0]=="riemann") then
    {
      textt:=concat(textt,"%%%%%%%%%%%%%%%% somme de Riemann %%%%%%%%%%%%%%%%%%%%%%%%

");
      xtmin:=evalf(V[1]);
      xtmax:=evalf(V[2]);
      texta:=("");
      nbp:=V[3];
      Q:=makemat(0,1,nbp);
      dx:=evalf((xtmax-xtmin)/nbp);
      for (k:=0;k<nbp;k++)
      {
        x:=evalf(xtmin+k*dx);
        if (abs(x)<0.0001) then
        {
          x:=0;
        }
        if (V[4]=="min") then
        {
          if (f(x)<=f(x+dx)) then
          {
            tmin:=f(x);
          }
          else
          {
            tmin:=f(x+dx);
          }
        }
        if (V[4]=="max") then
        {
          if (f(x)>=f(x+dx)) then
          {
            tmin:=f(x);
          }
          else
          {
            tmin:=f(x+dx);
          }
        }
        if (V[4]=="centre") then
        {
          tmin:=(f(x)+f(x+dx))/2
        }
        tmin:=evalf(tmin);
        if (abs(tmin)<0.0001) then
        {
          tmin:=0;
        }
        Q[k]:=tmin;
      }
      textt:=concat(textt,"aire:=("+xtmin+",0) placer");
      for (k:=0;k<nbp;k++)
      {
        textt:=concat(textt,"--("+(xtmin+k*dx)+","+Q[k]+") placer--("+(xtmin+(k+1)*dx)+","+Q[k]+") placer");
      }
      if (size(V)==6) then
      {
         textt:=concat(textt,"--("+(xtmax)+",0) placer--cycle;
fillcolor:=1.3"+V[5]+";
transparence aire;
draw aire;
");
      }
      else
      {
         textt:=concat(textt,"--("+(xtmax)+",0) placer--cycle;
draw hachurage(aire,30,4mm,0)"+V[5]+";
draw aire;
");
      }
      for (k:=1;k<nbp;k++)
      {
        textt:=concat(textt,"draw("+(xtmin+k*dx)+",0) placer--("+(xtmin+k*dx)+","+Q[k]+") placer;
");
      }
     }



  }
}





                        //  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                        //       % Creation du fichier metapost

Dessin:="
input dlf\_couleurs.mp;
input dlf\_tex.mp;
input dlf\_repere.mp;


numeric xmin,xmax,ymin,ymax,dx,dy;
numeric carx,cary,gradx,grady;
xmin:="+xmin+";
xmax:="+xmax+";
ymin:="+ymin+";
ymax:="+ymax+";
dx:=1cm/"+ux+";
dy:=1cm/"+uy+";
carx:="+cx+";
cary:="+cy+";
gradx:="+gx+";
grady:="+gy+";

pair a,b,c,d;
path aire;


beginfig(0);



"+grillage+"



draw(xmin,ymin) placer--(xmin,ymax) placer --(xmax,ymax) placer --(xmax,ymin) placer --cycle withpen pencircle scaled 1bp withcolor gris;

draw(xmin,0) placer--(xmax,0) placer;
draw(0,ymin) placer--(0,ymax) placer;
label.llft(TEX(\"$O$\"),(0,0)placer);


pair P[];

"+textp+"


"+textt+"

path limite;
limite:=(xmin*dx,ymin*dy)--(xmax*dx,ymin*dy)--(xmax*dx,ymax*dy)--(xmin*dx,ymax*dy)--cycle;
clip currentpicture to limite;

graduationstatx.bot(xmin,xmax,ymin,ymax,dx,dy,carx);
graduationstaty.lft(xmin,xmax,ymin,ymax,dx,dy,cary);

% titre
numeric titre;
titre:=0;

"+texti+"

if (titre=1):
  draw (xmin,ymax) placer shifted (0,0.1cm) --(xmax,ymax) placer shifted (0,0.1cm) withpen pencircle scaled 1bp withcolor gris;
  draw (xmin,ymax) placer shifted (0,1.3cm)--(xmax,ymax) placer shifted (0,1.3cm) withpen pencircle scaled 1bp withcolor gris;
fi;


endfig;
end
";
}:;
